#include <bits/stdc++.h>
using namespace std; // Define Variables
	string cur; // current location
	string des; // destination
	int sx, sy, sz, fx, fy, fz, ct, n, m, l; //for search
	int nowstp, d, vxs, vys, vzs, vxf, vyf, vzf, nextturn[3]; // for trace
	int dx[6] = {0, 0, -1, 1, 0, 0};
	int dy[6] = {-1, 1, 0, 0, 0, 0};
	int dz[6] = {0, 0, 0, 0, -1, 1};
	int v[100][200][5];
	struct node{
		int x;
		int y;
		int z;
		int step;
	};
	queue<node> q;
	stack<int> px;
	stack<int> py;
	stack<int> pz;
	// coodinates of each step in the shortest path
int isb[200][400][5];

void bfs(){ // generate the number of shortest steps for every block
	node startpos = {sx, sy, sz, 0};
	q.push(startpos);
	while(!q.empty()){
		node hd = q.front();
		q.pop();
		for(int i = 0; i < 6; i++){
			int xx = dx[i] + hd.x;
			int yy = dy[i] + hd.y;
			int zz = dz[i] + hd.z;
			int step = hd.step + 1;
			if(xx < 1 || yy < 1 || zz < 1 || xx > n || yy > m || zz > l || isb[xx][yy][zz] == 9 || v[xx][yy][zz] != 0){
				continue;
			}
			v[xx][yy][zz] = step;
			node nowpos = {xx, yy, zz, step};
			q.push(nowpos);
		}
	}
}

void dfs(int x, int y, int z){ // trace the matrix and generate the shortest path
	if(x == sx && y == sy && z == sz){
		return;
	}
	if(x < 1 || y < 1 || z < 1 || x > n || y > m || z > l || v[x][y][z] != nowstp - 1 || v[x][y][z] == 0){
        return;
    }
	nowstp--;
	px.push(x);
	py.push(y);
	pz.push(z);
	for(int i = 0; i < 6; i++){
		dfs(dx[i] + x, dy[i] + y, dz[i] + z);
	}
}

void out(){
	prx = px.top();
	pry = py.top();
	prz = pz.top();
	px.pop();
	py.pop();
	pz.pop();
	nox = px.top();
	noy = py.top();
	noz = pz.top();
	cout<<"Head to the direction of "<<isb[nox][noy][noz];
	vxs -= px.top();
	vys -= py.top();
	vzs -= pz.top();
	while(!px.empty()){
		if(px.top() == fx && py.top() == fy && pz.top() == fz){
			cout<<"You are there!"<<endl<<"导航结束"<<endl;
		}
		if()
	}
}

int main(void){ // main function

	//cin>>cur>>des;

	//This part is just for testing, remove after gathering isb data
	cin>>n>>m>>l;
	for(int k = 1; k <= l; k++){
		for(int i = 1; i <= n; i++){
			for(int j = 1; j <= m; j++){
				cin>>isb[i][j][k];
			}
		}
	}
    
	cin>>sx>>sy>>sz>>fx>>fy>>fz;

	bfs();
	nowstp = v[fx][fy][fz] + 1;
	dfs(fx, fy, fz);
	v[sx][sy][sz] = 0;

	for(int k = 1; k <= l; k++){
		for(int i = 1; i <= n; i++){
			for(int j = 1; j <= m; j++){
				cout<<v[i][j][k]<<' ';
			}
			cout<<endl;
		}
		cout<<endl;
	}
	
	cout<<endl<<"Every coordinate in the shortest path:"<<endl;
	cout<<sx<<' '<<sy<<' '<<sz<<endl;
	while(!px.empty()){
		cout<<px.top()<<' '<<py.top()<<' '<<pz.top()<<endl;
		px.pop();
		py.pop();
		pz.pop();
	}
	
	return 0;
}


/* PLAN
	6 - 10 classes

	Logic:
	- Data ()
	- Imput
	- Search (广搜)
	- Output

*/

/* Testing Data

	3 3 3

	0 0 0
	9 0 9
	0 0 0

	9 9 9
	0 0 0
	9 9 9

	0 0 0
	9 0 9
	0 0 0

	1 1 1 3 3 3

*/
